<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_17</title>
</head>
<body>
    <h1>Capitulo 17</h1>
    <a>Ejercicio 23</a>

    <script>

        let R = 6;
        let C = 5;
 
        function subCuadroMax(M) {
            let i,j;
            let S = [];
 
            for ( var y = 0; y < R; y++ ) {
                S[ y ] = [];
                for ( var x = 0; x < C; x++ ) {
                    S[ y ][ x ] = 0;
                }
            }

            let max_of_s, max_i, max_j;

            for(i = 0; i < R; i++)
                S[i][0] = M[i][0];
     
            for(j = 0; j < C; j++)
                S[0][j] = M[0][j];
         
            for(i = 1; i < R; i++) {
                for(j = 1; j < C; j++) {
                    if(M[i][j] == 1)
                        S[i][j] = Math.min(S[i][j-1],Math.min( S[i-1][j],S[i-1][j-1])) + 1;
                    else
                        S[i][j] = 0;
                }
            }
     
            max_of_s = S[0][0]; max_i = 0; max_j = 0;

            for(i = 0; i < R; i++) {
                for(j = 0; j < C; j++) {
                    if(max_of_s < S[i][j]) {
                        max_of_s = S[i][j];
                        max_i = i;
                        max_j = j;
                    }
                }            
            }
 
            document.write("<br> EL subcuadrado Máximo es: <br>");
        
            for(i = max_i; i > max_i - max_of_s; i--) {
                for(j = max_j; j > max_j - max_of_s; j--) {
                    document.write( M[i][j] , " ");
                }
                document.write("<br>");
            }
        }
 
 

        let M = [[0, 1, 1, 0, 1],
                 [1, 1, 0, 1, 0],
                 [0, 1, 1, 1, 0],
                 [1, 1, 1, 1, 0],
                 [1, 1, 1, 1, 1],
                 [0, 0, 0, 0, 0]];
                     
        subCuadroMax(M);

    </script>
    
</body>
</html>